<template>
    <div class="">
            <button @click="showModalOnCreate"  class="add-button-mobile ml-4 btn btn-xs btn-secondary text-xs"> 
                           <i class="fas fa-plus-circle right "></i>  
            </button>
            <page-header title="Entreprises">
              <span slot="btn">

              </span>
              <div slot="nav">
                <div  class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3"></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a href="javascript:void(0);"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                    </div>
                    </div>
              </div>
            </page-header>
             <div class="row">
               <div class="col-md-2">
                 <div :class="['card bg-transparent']" >
                     <div class="card-header card-header-filtre pl-0" style="" >
                             <h3 class="card-title mb-0 hidden-xs d-flex" style="">

                        <i class="fas fa-filter mr-1 ml-1" style="line-height:inherit"></i> Filtres
                        </h3>
                         <div class="card-tools ">
                           <button  title="Retiter tous les filtres" v-if="anyFilter" @click="removeAllFilters" class="btn btn-xs btn-default button-retrait-filtre">
                              <i class="fas fa-times-circle"></i> Retirer les filtres
                           </button>
                         </div>
                     </div>
                 </div>
                 <div class="d-flex flex-column">
                    <div class="form-group ">
                     <label class="">Pays d'origine</label>
                      <multi-select class="country "
                            no-ptions="Aucun revendeur disponible" open-direction="bottom"
                            v-model="pays"  :options="_pays"
                            @input="trackPays" 
                            :show-labels="false" :searchable="true" :clear-on-select="false"
                            :close-on-select="true"  placeholder="Filtre par pays" label="libelle" track-by="id">
                                <span slot="noOptions">
                                    Aucune pays disponible 
                                </span>
                                <span slot="noResult">Aucun élement trouvé</span>
                        </multi-select>
                          </div>
                    <div class="form-group ">
                        <label class="">Secteurs d'Activité</label>
                        <multi-select class="" @input="trackSecteurActivite" name="secteur_activite_id"
                                                        v-model="secteur" :show-labels="false"
                                                        open-direction="bottom" :close-on-select="true" placeholder="Filtre par secteur"
                                                        :options="_secteurs"   label="libelle" track-by="id">

                                                           <span slot="noOptions">
                                                               Aucune secteur d'activité disponible 
                                                           </span>
                                                           <span slot="noResult">Aucun élément trouvé</span>
                        </multi-select>
                    </div>
                    <div class="form-group ">
                        <label class="">Forme juridique</label>
                        <multi-select class="" @input="trackFormeJuridique" 
                            v-model="forme_juridique" :show-labels="false"
                            open-direction="bottom" :close-on-select="true" placeholder="Filtre par Forme juridique"
                            :options="_formes_juridiques"   >

                                <span slot="noOptions">
                                    La liste est vide 
                                </span>
                                <span slot="noResult">Aucun élément trouvé</span>
                        </multi-select>
                    </div>

                 </div>
               </div>
            
            <div id="bloc" class="col-md-10 bloc">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title mb-0 hidden-xs d-flex">
                      <button  @click="call"  class="ml-2 btn  btn-secondary text-xs"> 
                           <i class="fas fa-plus-circle right "></i>  Nouveau
                      </button>
                    </h3> 

                    <div class="card-tools d-flex">
                         <filter-bar ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <!-- /.card-body -->
               </div>
               <div class="row" v-if="items.length>0">
                 <entreprise-item v-for="(membre,index) in items"   :entity="membre" :key="index"></entreprise-item>

               </div>
               <div class="row" v-else>
                    <p class="text-center w-100 mt-5" v-show="!loading">Aucune donnée disponible
                        <span v-show="hasSearchedOrFilteredData"> pour votre recherche</span>
                     </p>
              </div>
               <div class="swrapper d-flex justify-content-center mt-2 mb-3" v-if="moreExists">
                       <a :class="[loading ? 'btn disabled' : '']" href="javascript:void(0)" @click.prevent="loadMore($event,null)"><span>VOIR 
                         <i :class="['fas  mt-1',loading ? 'fa-circle-notch' : 'fa-arrow-down']"></i> PLUS</span></a>
              </div>
              <!-- Modal dbt -->
                                <nouveau-membre v-if="visible"></nouveau-membre>
              <detail-enterprise v-if="visible"></detail-enterprise>
              <nouvelle-entreprise @new-enterprise-added="addMember" v-if="visible" @option-fetch-event='getOption'></nouvelle-entreprise>

</div>
 </div>
    </div>
</template>

<script>

   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../components/pagination/Pagination'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";
   import EntrepriseItem from "./EntrepriseItem.vue";
   import NouvelleEntreprise from "./NouvelleEntreprise.vue";
   import NouveauMembre from "./../membres/NouveauMembre.vue";

   import DetailEnterprise from "./DetailEnterprise.vue";

   import DocumentInput from "./../../components/DocumentInput"

import { mapGetters } from 'vuex'

    export default {
        mixins: [Master],
        data(){
            return{
                modeEdit:false,
                ftime:true,
                upadatedTimes:3,
                contentLoaded:false,
                membres :[],
                hasData:false,
                visible:false,
                date_naissance:'',
                maxDate:"",

                moreParams:{filter:"",filter_pays:"",filter_promotion:"",filter_secteur:"",filter_forme_juridique:""},
                isLoading:false,

                //FILTRE 
                pays:"",
                secteur:"",
                forme_juridique:""
  
            }
        },
        created()
        {
          this.modeEdit = false
          window.event.$emit("isLoading",true) 
          this.$store.dispatch('enterprises/init')
          this.$store.dispatch('enterprises/getEnterprises')
          //this.fetch()
        },
        mounted() {


          this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
          this.$events.$on('filter-reset', e => this.onFilterReset())         
          this.visible = true
          var vm = this
           $(window).on('load',function () {
                
                vm.contentLoaded = true
            });


        },
        computed:
        {
            ...mapGetters({ _pays:"params/_pays",_secteurs:'params/_secteurs',_promotions:"params/_promotions",_formes_juridiques:'params/_formes_juridiques'
                           ,moreExists:'enterprises/moreExists',next_page_url:"enterprises/next_page_url",total:"enterprises/total"
                           ,current_page:"enterprises/current_page",items:"enterprises/_items",loading:"enterprises/loading",loaded:"enterprises/loaded"}),


            page_loaded()
            {
              return  this.loaded ;
            },
            anyFilter()
            {
              return this.moreParams.filter_forme_juridique !="" || this.moreParams.filter_pays !="" || this.moreParams.filter_secteur !=""   
            },
             hasSearchedOrFilteredData()
            {
              return this.anyFilter || this.moreParams.filter !=""   
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            },
            excelUrl()
           {
             return '/clients/export?format=excel&filter='+this.moreParams.filter
           },
           pdfUrl()
           {
             return '/depenses/export?format=pdf&q='+this.searchTxt
           },
        },
        methods: 
        {
             loadMore(event,page=null)
             {

                if(page=="null" || page==null)
                page =""

                var p = !isDefined(page) ? this.current_page+1 : page
                var query = "?page="+p
                this.moreParams.query = ""
                for(var propertyName in this.moreParams) {
                    
                    query +="&"+propertyName+"="+this.moreParams[propertyName]
                 
               }
                
                this.moreParams.query = query;
                query = ""
                this.$store.dispatch('enterprises/getEnterprises',this.moreParams)

               
             },
             // Events
             trackSecteurActivite(e)
             {
                 if(e!=null)
                 {
                   this.moreParams.filter_secteur = e.id
                 }
                 else
                 {
                    this.moreParams.filter_secteur = ""
                 }
                 this.loadMore(null,1)

             },
              trackPays(e)
             {
                 if(e!=null)
                 {
                   this.moreParams.filter_pays = e.id
                 }
                 else
                 {
                    this.moreParams.filter_pays = ""
                 }
                 this.loadMore(null,1)
             },
              trackFormeJuridique(e)
             {
                 if(e!=null)
                 {
                   this.moreParams.filter_forme_juridique = e
                 }
                 else
                 {
                    this.moreParams.filter_forme_juridique = ""
                 }
                 this.loadMore(null,1)
             },
            addMember(membre)
            {
                 this.membres.push(membre)
            },
            removeAllFilters()
            {
                 this.moreParams.filter_forme_juridique=""
                 this.moreParams.filter_pays=""
                 this.moreParams.filter_secteur=""
                 this.secteur=""
                 this.pays=""
                 this.forme_juridique=""
                 this.loadMore(null,1)
            },
              getOption(e)
             {
               //this.options.secteurs = e
             },
                          fetch()
             {
                var url = "/api/membres"
                

        
                axios.get(url).then((response) => 
                { 

                       this.membres = response.data.data
                       

                       window.event.$emit("isLoading",false)
                       if(this.init==true)
                        {
                          this.init =false
                        }
                        if(this.pageInit==false)
                        {
                            this.pageInit =true
                        }
                        window.scrollTo(0,0)
                       
                },
                (error) => {
                         console.log("Promise Rejected:")

                });
             },
            call()
            {
              window.event.$emit('new-enterprise-event')
            },

            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            onPaginationData (paginationData) 
            {
              if(this.pageInit==false)
                 this.pageInit =true
              else
              {
                 
              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onLoading() 
            {


                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                
            },
            onLoadingDone() 
            {
               this.labels()
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },

            onFilterSet (filterText) {
                this.moreParams.filter = filterText
                this.loadMore(null,1)
            },
            onFilterReset () {
                this.moreParams.filter = ""
                Vue.nextTick( () => this.loadMore(null,1))
            },

            //On affiche le modal pour la création
            showModalOnCreate()
            {
    
                this.modeEdit = false
                this.reset()
                this.$refs['inputModal'].show()
              
            }
              
        },
        components:
        {

            Vuetable,
            pa,
            DocumentInput,
            EntrepriseItem,
            DetailEnterprise,
            NouvelleEntreprise,
            NouveauMembre
        },
        updated: function () {
            this.$nextTick(function ()
            {
              if(this.current_page > 1)
              window.scrollTo(0,document.body.scrollHeight);
            })
         },
             watch: {
        page_loaded(newValue) {
           if(newValue == true && this.pageInit == false)
            this.pageInit = true
        },
         loading(newValue) {
               log('oook')
        },
        "moreParams.filter_promotion"(newValue) {
              if(newValue==null)
              this.moreParams.filter_promotion =""
               this.loadMore(null,1)
        }
    }
    }
</script>
<style lang="scss">
.swrapper{
    text-align: center;
  
a{
  display: block;
  width: 200px;
  height: 40px;
  line-height: 40px;
  font-size: 14px;
  font-family: sans-serif;
  text-decoration: none;
  color: #333;
  border: 2px solid #333;
  letter-spacing: 2px;
  text-align: center;
  position: relative;
  transition: all .35s;
}

a span{
  position: relative;
  z-index: 2;
}

a:after{
  position: absolute;
  content: "";
  top: 0;
  left: 0;
  width: 0;
  height: 100%;
  background: #001f3f;
  transition: all .35s;
}

a:hover{
  color: #fff;
}

a:hover:after{
  width: 100%;
}
}


.car-card .tarif {
  font-weight: 700;
  color: #e60000;
  font-size: 26px;
    font-weight: bold;
}
.car-card .tarif span.details {
  font-size: 18Px;
  font-weight: lighter;
}


.car-card .card-body {
  
  height: 200px;
}
.car-card .media-link img {
  
  height: 200px;
}
.car-card .info li div i  {
   font-size: 1.65rem;
       line-height: 1.6;
}


    .car-card .title {
      font-size: 15px;
      font-weight: 700;
    }

    .car-card .media-link {
      padding: 0;
      display: block;
      position: relative;
      overflow: hidden;
      text-align: center;
  }

  .car-card  .media-link .icon-view {
    position: absolute;
    top: 50%;
    left: 50%;
    margin-left: -40px;
    margin-top: -40px;
    opacity: 0;
    -webkit-animation: fadeOut .4s;
    animation: fadeOut .4s;
}
.car-card .card-header{
        border-bottom: 1px solid rgba(0, 0, 0, 0.04);

}
.car-card .icon-view {
  width: 80px;
  height: 80px;
  padding: 5px;
  border: solid 1px rgba(0, 0, 0, 0.6);
  border-radius: 50%;
  display: inline-block;
}
.car-card  .icon-view strong {
  display: block;
  width: 68px;
  height: 68px;
  border-radius: 50%;
  text-align: center;
  background-color: rgba(0, 0, 0, 0.6);
  color: #ffffff;
}
.car-card .info li {
  height: 30px;
  line-height: 20px;
  font-size: 10px;
  font-weight: bold;
  text-align: center;
  width: 100%;
  padding: 3px 0 3px 0;
}
.car-card .info {
  display: -webkit-flex;
  -webkit-justify-content: space-between;
  display: flex;
  justify-content: space-between;
  white-space: nowrap;
}

.clearfix {
  zoom: 1;
}
.car-card .info li:first-child div {
  border-left: none;
}

.car-card .info li div {
  padding: 0 9px;
  border-left: 1px solid #ffd200;
  margin-top: 5px;
  color: #6c757d;
}
.clearfix:after {
  content: ".";
  display: block;
  height: 0;
  clear: both;
  visibility: hidden;
}
.car-card .block-info {
  background: #f2f2f2;
  width: 100%;
}
.car-card .block-info ul {
    list-style: none;
}
.car-card .info li {
  height: 30px;
  line-height: 20px;
  font-size: 10px;
  font-weight: bold;
  text-align: center;
  width: 100%;
  padding: 3px 0 3px 0;
}
.card-car .image-block {
    border: none;
    padding-right: 0px;
    background-color: white;
}
.car-card .card-car-body
{
   min-height: 200px;
}
.car-card .block-data
{
      padding-bottom: 0px !important;
    padding-top: 0px !important;
}
/* 
  ##Device = Desktops
  ##Screen = 1281px to higher resolution desktops
*/

@media (min-width: 1281px) {
  
  //CSS
  
}

/* 
  ##Device = Laptops, Desktops
  ##Screen = B/w 1025px to 1280px
*/

@media (min-width: 1025px) and (max-width: 1280px) {
  
  //CSS
  
}

/* 
  ##Device = Tablets, Ipads (portrait)
  ##Screen = B/w 768px to 1024px
*/

@media (min-width: 768px) and (max-width: 1024px) {
  
  //CSS
  
}

/* 
  ##Device = Tablets, Ipads (landscape)
  ##Screen = B/w 768px to 1024px
*/

@media (min-width: 768px) and (max-width: 1024px) and (orientation: landscape) {
  
  //CSS
  
}

/* 
  ##Device = Low Resolution Tablets, Mobiles (Landscape)
  ##Screen = B/w 481px to 767px
*/

@media (min-width: 481px) and (max-width: 767px) {
  
  //CSS
  
}

/* 
  ##Device = Most of the Smartphones Mobiles (Portrait)
  ##Screen = B/w 320px to 479px
*/

@media (min-width: 320px) and (max-width: 480px) {
  .content-card .content-card-title .card-title a
  {
    margin-left: 0px !important;
  }

  .car-card .card-body
   {
    height: auto;
   }
   .car-card .block-details
   {
     padding-top: 0px !important;
   } 
    .car-card .card-body .card-car-body
   {
     flex-direction: column;
    -ms-flex-direction: column;
   }
.card-car .image-block {
    border: none;
    min-height: 223px;
    padding-right: 0px !important;
}
   .car-card .media-link img {
    height: auto;
    width: 100%; 
}
.car-card .block-info {
    background: #f2f2f2;
     position: relative; 
    width: 100%;
    right: 0px;
    bottom: 0px;
}
.car-card .block-data {
    padding-bottom: 0px !important;
    padding-top: 0px !important;
}
.car-card .block-info ul {
    list-style: none;
    margin-bottom: 0px;
}

.car-card .card-footer {

        border-top: 1px solid rgba(0, 0, 0, 0.04);
}
.car-card .info li div {
    padding: 0 0px;
    border-left: none;
    margin-top: 0px;
        display: -webkit-box !important;
    display: flex !important;
    -webkit-box-pack: center !important;
    justify-content: center !important;
}
.car-card .info li div span  {
      font-size: 0.9rem;
    margin-left: 5px;
    line-height: 2.4;
}
.car-card .info li div i  {
   font-size: 1.4rem;
       line-height: 1.6;
}
.car-card .info li {
    line-height: 20px;
    font-size: 10px;
    font-weight: bold;
    text-align: center;
    width: 100%;
    padding: 0px !important;
        padding-left: 5px !important;
    padding-right: 5px !important;
    border-left: 1px solid #ffd200;
}
.car-card .info li:first-child {
    
    border-left: none;
}
.car-card .block-details p i {
   border-left: none;
 }


}
.entreprise-item .card .view {
   min-height: 175.94px;
}
</style>